
#include "Arduino.h"
#include "GPS.h"
#include "SoftwareSerial.h"


 SoftwareSerial GPS_serial(8,12); //Rx, Tx lerroak 8 eta 12 hankatxoak serie komunikaziorako erabiliko direnak
 
 /*
 p1, p2 eta p3 GPS/GSM moduak aukeratzeko erabiliko diren 3 hankatxoak dira, GPSko 3,4 eta 5 pinak 
 mikrokontrolagailuko zein pinekin konektaturik dauden hurrenez hurren.
 */
 
 GPS::GPS(int p1, int p2, int p3) 
 {   
     _p1=p1;
     _p2=p2;
     _p3=p3;
     pinMode(_p1, OUTPUT);
     pinMode(_p2, OUTPUT);
     pinMode(_p3, OUTPUT);
 }
 
 void GPS::konfiguratu(){   //Konfiguratu modulua GPSak modu autonomoan lan egiteko
   
     GPS_serial.begin(9600);
     digitalWrite(_p3, HIGH);
     delay(1500);
     digitalWrite(_p3, LOW);
     digitalWrite(_p1,LOW);//GSM Moduan jarri
     delay(2000);
     digitalWrite(_p2,HIGH);//GPS modua desgaitu
     delay(2000);
     //GPSa elikatu
     GPS_serial.println("AT+CGPSPWR=1");
     delay(2000); 
     //GPSa modu autonomoan berrabiarazi
     GPS_serial.println("AT+CGPSRST=1");
     delay(2000); 
     digitalWrite(_p2,LOW);//GPS modua aktibatu
     digitalWrite(_p1,HIGH);//GSM modua desaktibatu
    
     
}    

 
//GPS/GSM/GPRS moduluaren webgune ofizialeatik eskuratutako funtzioak : http://www.dfrobot.com/wiki/index.php/GPS/GPRS/GSM_Module_V3.0_(SKU:TEL0051)
   
double Datatransfer(char *data_buf,char num)//convert the data to the float type
{                                           //*data_buf?the data array                                       
  double temp=0.0;                           //the number of the right of a decimal point
  unsigned char i,j;
 
  if(data_buf[0]=='-')
  {
    i=1;
    //process the data array
    while(data_buf[i]!='.')
      temp=temp*10+(data_buf[i++]-0x30);
    for(j=0;j<num;j++)
      temp=temp*10+(data_buf[++i]-0x30);
    //convert the int type to the float type
    for(j=0;j<num;j++)
      temp=temp/10;
    //convert to the negative numbe
    temp=0-temp;
  }
  else//for the positive number
  {
    i=0;
    while(data_buf[i]!='.')
      temp=temp*10+(data_buf[i++]-0x30);
    for(j=0;j<num;j++)
      temp=temp*10+(data_buf[++i]-0x30);
    for(j=0;j<num;j++)
      temp=temp/10 ;
  }
  return temp;
}
 
char ID()//Match the ID commands
{ 
  
  int j=0;
  char i=0;
  char value[6]={
    '$','G','P','G','G','A'      };//match the gps protocol
  char val[6]={
    '0','0','0','0','0','0'      };
 
  while(1)
  {
    
    j++;
    if(GPS_serial.available())
    {
      val[i] = GPS_serial.read();//get the data from the serial interface
      if(val[i]==value[i]) //Match the protocol
      {    
        i++;
        if(i==6)
        {
          i=0;
          return 1;//break out after get the command
        }
      }
      else
        i=0;
    }
    else{
       // Serial.println("GPS_serial not available");
        //return 0;
    }
  } 
}
 
void comma(char num)//get ','
{   
  char val;
  char count=0;//count the number of ','
 
  while(1)
  {
    if(GPS_serial.available())
    {
      val = GPS_serial.read();
      if(val==',')
        count++;
    }
    if(count==num)//if the command is right, run return
      return;
  }
 
}
 
 
 void GPS::UTC(){
   
  char i;
  char time[9]={
    '0','0','0','0','0','0','0','0','0'
  };
  double t=0.0;
 
  if( ID())//check ID
  {
    
    comma(1);//remove 1 ','
    //get the datas after headers
    while(1)
    {
     
      if(GPS_serial.available())
      {
        time[i] = GPS_serial.read();
        i++;
      }
      if(i==9)
      {
        i=0;
        t=Datatransfer(time,2);//convert data
        //t=t-30000.00;//convert to the chinese time GMT+8 Time zone
        long time=t;
        int h=time/10000;
        int m=(time/100)%100;
        int s=time%100;
        
//        if(h>=24)               //UTC+
//        {
//        h-=24;
//        }
 
         if (h<0)               //UTC-
        {
          h+=24;
        }
        Serial.print(h);
        Serial.print("h");
        Serial.print(m);
        Serial.print("m");
        Serial.print(s);
        Serial.println("s");
 
        //Serial.println(t);//Print data 
        return;
      }  
    }
  }
 }
 
 
 
 
 void GPS::latitudea(){
      Serial.println(" ");
      Serial.print("LATITUDEA :  ");
      char i;
  char lat[10]={
    '0','0','0','0','0','0','0','0','0','0'
  };
 
 
  if( ID())
  {
    comma(2);
    while(1)
    {
      if(GPS_serial.available())
      {
        lat[i] = GPS_serial.read();
        i++;
      }
      if(i==10)
      {
        i=0;
        //Serial.println(Datatransfer(lat,5)/100.0,7);//print latitude 
        Serial.print(Datatransfer(lat,5)/100.0,7);//print latitudE
        Serial.print(" ");
        return;
      }  
    }
  }
 }
 
 
 void GPS::latitudea_norantza(){
       char i=0,val;
 
  if( ID())
  {
    comma(3);
    while(1)
    {
      if(GPS_serial.available())
      {
        val = GPS_serial.read();
        Serial.write(val);
        Serial.println();
        i++;
      }
      if(i==1)
      {
        i=0;
        return;
      }  
    }
  }
 }
 
 
 void GPS::longitudea(){
      Serial.println(" ");
      Serial.print("LONGITUDEA :  ");
 char i;
  char lon[11]={
    '0','0','0','0','0','0','0','0','0','0','0'
  };
 
  if( ID())
  {
    comma(4);
    while(1)
    {
      if(GPS_serial.available())
      {
        lon[i] = GPS_serial.read();
        i++;
      }
      if(i==11)
      {
        i=0;
       // Serial.println(Datatransfer(lon,5)/100.0,7);
       Serial.print(Datatransfer(lon,5)/100.0,7); //Inprimatu longitudea
       Serial.print(" ");
        return;
      }  
    }
  }
  
      
 }
 
 
 void GPS::longitudea_norantza(){
  char i=0,val;
 
  if( ID())
  {
    comma(5);
    while(1)
    {
      if(GPS_serial.available())
      {
        val = GPS_serial.read();
        Serial.write(val); //Serial.println(val,BYTE);
        Serial.println();
        i++;
      }
      if(i==1)
      {
        i=0;
        return;
      }  
    }
  }
 }
 
 
 void GPS::altitudea(){
      char i,flag=0;
  char alt[8]={
    '0','0','0','0','0','0','0','0'
  };
 
  if( ID())
  {
    comma(9);
    while(1)
    {
      if(GPS_serial.available())
      {
        alt[i] = GPS_serial.read();
        if(alt[i]==',')
          flag=1;
        else
          i++;
      }
      if(flag)
      {
        i=0;
        Serial.println(Datatransfer(alt,1),1);//print altitude data
        return;
      }  
    }
  }
 }
 
 
 
