/*
Ultrasoinu sentsorea konfiguratzeko programa: 

    muga_balioa (threshold = 50 cm)
    
Konexioak: 

  Rx -- 11
  Tx -- 10  
  
  gnd -- gnd
  5V -- 5V

*/    
   

#include <SoftwareSerial.h>

#define RxD 10
#define TxD 11

#define LED 13

SoftwareSerial ULSerial(RxD, TxD); //Ultrasoinuaren serie komunikazioa


//muga balioa 50 cm-tan konfiguratzeko beharrezko hiru komandoak

int cmmd1[]={0x44,0x02,0xaa,0xf0};//Modu autonomoa: idatzi 0xaa 0x02 helbidean
int cmmd2[]={0x44,0x00,0x32,0x76};//Muga balioaren pisu txikieneko bytea idatzi 0x00 helbidean
int cmmd3[]={0x44,0x01,0x00,0x45};///Muga balioaren pisu handieneko bytea idatzi 0x01 helbidean


int i;
int led=13; //Led hau erabiliko dugu programaren exekuzioa zein momentutan dagoen jakiteko
 
 
void setup(){      
  pinMode(led, OUTPUT);  
  delay(2000);
  digitalWrite(led, HIGH); //Argia piztu 
  delay(2000);
  digitalWrite(led, LOW); //Argia itzali, moduluan idazten ari den seinale
  Serial.begin(9600); 
  ULSerial.begin(9600);
  A_Mode_Setup();   //Komandoak bidali ultrasoinura
  digitalWrite(led, HIGH);  //Argia piztu idazten bukatu den seinale
}
 
void loop()
{
}                      
 
void A_Mode_Setup(){ 
  
  //Datuak idatzi URM37 EEPROM-en
  
  for (i=0;i<4;i++) ULSerial.write(cmmd1[i]);    
  delay(2000);                                           
 
  Serial.println(i); //Komando baten bidalketarekin amaitu dela adierazteko
  
  for (i=0;i<4;i++)ULSerial.write(cmmd2[i]);
  delay(2000);

  Serial.println(i);
  
  for (i=0;i<4;i++) ULSerial.write(cmmd3[i]);
  delay(2000);
  
  Serial.println(i);
 
}
