/*
Programa honen bidez, OUTDOOR robota urrunetik kontrola daiteke, Androideko RC Car aplikazioa erabiliz. 
Robotak ultrasoinu sentsorea du aurrean eta oztoporen batera 50cm-ra gerturatzen denean, automatikoki robota
geratu egingo da. Kasu horretan ezin izango da inolaz ere aurrera egin, eta beraz, mugikorretik atzerako aginduak
soilik onartuko dira. Bestalde, unero robota bere egoeraren berri emateko mezuak bidaltzen dizkio echo zerbitzariari.
Honetarako, robota eta echo zerbitzaria wifi sare berera konektatu behar dira

OSAGAIAK: 
 - Motorrak
 - Bluetooth
 - Ultrasoinu sentsorea
 - Wifi shield
*/

#include <SoftwareSerial.h>
#include <Motorrak.h>
#include <Wifi.h>

//Bluetooth
#define RxD 10
#define TxD 11

SoftwareSerial BTSerial(RxD, TxD);


//Motorren objektua sortu
Motorrak motorrak(4,5,7,6,0);


//Wifi konexiorako parametroak

String AP_izena="nireAP"; //Wifi sarearen AP izena
String AP_pass="123456789"; //Wifi sarearen pasahitza
String zerb_helb="192.168.43.211"; //Echo zerbitzariaren IP helbidea
String zerb_portua="50001"; //Echo zerbitzariaren portua

Wifi wifi;

//Robota arriskuan dagoen edo ez adierazteko aldagaia
volatile boolean ARRISKUAN = false;


void setup()
{
  //BLuetooth konfigurazioa
  BTSerial.begin(9600); //Komunikazio abiadura finkatu
  BTSerial.flush(); //Portu serieko memoria garbitu
  delay(500);
  
  // Wifia konfiguratu 
  konfiguratu_wifi();
  delay(5000);
  //Ultrasoinuko etenenen zerbitzu errutina
  attachInterrupt(0, oztopoa, CHANGE); //Ultrasoinuaren TRIG hankan (pin 2) aldaketa sumatzean oztopoa() zerbitzu errutina exekutatu
      


}

 /// *** MAIN *** ///
 
void loop()
{
       // Itxaron komandoren bat jaso arte
      if (BTSerial.available()){
        
          // Irakurri jasotako komandoa
          char komandoa = BTSerial.read();
          BTSerial.flush(); //Cache memoria garbitu
       
         
          //Komandoa prozesatu
          switch(komandoa){
       
             case 'F': //Aurrera
               if(!ARRISKUAN){
                motorrak.aurrera();
               }    
               else{
                  wifi.bidali("Oztopoa gertuegi. Ezin da aurrera egin");
                }
               break;
             
              case 'B': //Atzera
                motorrak.atzera();
                break;
         
              case 'L': //Ezkerrera
                motorrak.ezkerrera();
                break;
         
              case 'R': //Eskuinera
                motorrak.eskuinera();
                break;
               
              case 'I': //Aurrera-Eskuinera
                if(!ARRISKUAN){
                  motorrak.aurreraEskuinera();
                }
                else{
                  wifi.bidali("Oztopoa gertuegi. Ezin da aurrera egin");
                }
                break;
               
              case 'G': //Aurrera-Ezkerrera
                if(!ARRISKUAN){
                  motorrak.aurreraEzkerrera();
                }
                else{
                  wifi.bidali("Oztopoa gertuegi. Ezin da aurrera egin");
                }  
                break;
               
              case 'H': //Atzera-Ezkerrera
                 motorrak.atzeraEzkerrera();
                 break;
               
              case 'J': //Atzera-Eskuinera
                 motorrak.atzeraEskuinera();
                 break;
                                   
             case '0': 
                 motorrak.aldatuAbiadura(0);
                 break;
              
              case '1': 
                 motorrak.aldatuAbiadura(50);
                 break;   
                 
              case '2': 
                 motorrak.aldatuAbiadura(100);
                 break;   
               
              case '3': 
                 motorrak.aldatuAbiadura(150);
                 break;
               
               case '4': 
                 motorrak.aldatuAbiadura(175);
                 break;
          
               
               case '5':
                   motorrak.aldatuAbiadura(200);
                  break;
                  
               case '6':
                   motorrak.aldatuAbiadura(210);
                   break;
         
               case '7':
                  motorrak.aldatuAbiadura(220);
                  break;       
                  
               case '8':
                   motorrak.aldatuAbiadura(230);
                   break;
                   
               case '9':
                   motorrak.aldatuAbiadura(240);
                   break;
                   
               case 'q':
                   motorrak.aldatuAbiadura(255);
                   break;    
                                 
               case 'S': //Gelditu
                 motorrak.gelditu();
                 break;
              
               case 'D':
                 motorrak.gelditu();
                 delay(1000);
                 wifi.bidali("Programa amaitzear");
                 exit(0);  
                 break;
        
               default:
                  wifi.bidali("Komando okerra");
         }  
       
     }
   
}


//Ultrasoinu sentsorearen zerbitzu errutina

void oztopoa(){
   int trigger=digitalRead(2);
   if (trigger==0){ //Oztopoa gertuegi
      ARRISKUAN=true;
      wifi.bidali("Arriskuan");
      //Motorrak gelditu
      motorrak.gelditu();
   }
  else{ //Oztopoa ekidin da
    ARRISKUAN=false;
    wifi.bidali("Arriskutik kanpo");
  }
}  

//Konektatu wifi sarera eta hasi komunikazioa socketarekin
void konfiguratu_wifi(){
   wifi.AP_pass(AP_pass);
   wifi.dhcp(1);
   wifi.AP_izena(AP_izena);
   wifi.socketa_sortu("0", "0", zerb_helb, zerb_portua);
   wifi.hasi_komunikazioa();
   delay(5000);
}
