
#include "Arduino.h"
#include "Wifi.h"


 Wifi::Wifi()  //Eraikitzailea
 {
    Serial.begin(115200);    
         
 }            


 void Wifi::AP_izena(String izena) //Konektatu nahi dugun AP-ren izena zehaztu
 {
     Serial.println("AT+WAUTO=0,"+izena);
	 delay(2000);
 }

 void Wifi::AP_pass(String pass) //Konektatu nahi dugun AP-ren pasahitza zehaztu
 {
     Serial.println("AT");
     delay(2000);
     Serial.println("AT+WWPA="+pass);  
	 delay(1000);	 
 }


 void Wifi::dhcp(int n) //Helbide esleipen dinamikoa edo estatikoa aukeratzeko funtzioa
 {
      if(n==0){
         Serial.println("AT+NDHCP=0");
      }
      else{
         Serial.println("AT+NDHCP=1");
      }   
		delay(2000);
 }
  
  
void Wifi::helbidea_esleitu(String helbidea, String maskara, String gateway) //Helbide esleipen estatikoa egiteko
{
     Serial.println("AT+NSET="+helbidea+","+maskara+","+gateway);      
}       
  
 /*Socketa sortu honako parametro hauek finkatuz:
           - Rola: Zerbitzaria (1) edo bezeroa (0)
           - Erabiliko den protokoloa: TCP (1) edo UPD (0)
           - Helbidea: socketa zein IP helbidedun makinakin konektatuko dugun
           - Portua: Makina horretako zein portutara egingo den komunikazioa           
 */          
 
 void Wifi::socketa_sortu(String rol, String protokoloa, String helbidea, String portua) 
 {
   Serial.println("AT+NAUTO="+protokoloa+","+rol+","+helbidea+","+portua);    
   delay(2000);
    
 }     
 
 void Wifi::hasi_komunikazioa() //Socket bidezko komunikazioa hasi
 {
      Serial.println("ATA"); 
      delay(2000);	 
      Serial.println("Robotarekin komunikazioa finkatuta");
      
 }
 
 void Wifi::bidali(String mezua){ //Socketaren bidez mezua bidaltzeko funtzioa
      Serial.println(mezua);
  }    

void Wifi::deskonektatu()
{
     Serial.println("AT+WD");
}     

     

