
#include "Arduino.h"
#include "Motorrak.h"


//Klaseko funtzio eraikitzailea. Deian erabiliko diren pin-ak zein diren zehaztu beharko da; bai eta hasierako abiadura ere.
Motorrak::Motorrak(int esk_norantza, int esk_abiadura, int ezk_norantza, int ezk_abiadura, int abiadura)
{
   // Ezker motorrak
   _ezk_norantza=ezk_norantza;
   _ezk_abiadura=ezk_abiadura;
   pinMode(_ezk_norantza, OUTPUT); 
   pinMode(_ezk_abiadura, OUTPUT);
   
  //Eskuin motorrak 
   _esk_norantza=esk_norantza;
   _esk_abiadura=esk_abiadura;
   pinMode(_esk_norantza, OUTPUT);
   pinMode(_esk_abiadura, OUTPUT);
 
   //Hasierako abiadura
   _abiadura=abiadura;
}   

void Motorrak::aurrera() //Motor guztiak aurreraka biratu uneko abidaurarekin
{
    digitalWrite(_esk_norantza, HIGH);
    analogWrite(_esk_abiadura, _abiadura);
    digitalWrite(_ezk_norantza, HIGH);
    analogWrite(_ezk_abiadura, _abiadura);
    Serial.println("Aurrera");
}

void Motorrak::atzera()//Motor guztiak atzeraka biratu uneko abidaurarekin
{
     digitalWrite(_esk_norantza, LOW);
     analogWrite(_esk_abiadura, _abiadura);
     digitalWrite(_ezk_norantza, LOW);
     analogWrite(_ezk_abiadura, _abiadura);
     Serial.println("Atzera");
}

void Motorrak::eskuinera() //Eskuinera egin uneko norantza errespetatuz (atzera edo aurrera)
{
     analogWrite(_esk_abiadura, 0);
     analogWrite(_ezk_abiadura, _abiadura); 
     Serial.println("Eskuinera");
}     

void Motorrak::ezkerrera() //Ezkerrera egin uneko norantza errespetatuz (atzera edo aurrera)
{
     analogWrite(_esk_abiadura, _abiadura);
     analogWrite(_ezk_abiadura, 0);
     Serial.println("Ezkerrera");
} 


void Motorrak::aurreraEskuinera() //Aurrera eskuineraka joan
{
    digitalWrite(_esk_norantza, HIGH);
    digitalWrite(_ezk_norantza, HIGH);
    analogWrite(_esk_abiadura, _abiadura-125);
    analogWrite(_ezk_abiadura, _abiadura);
    Serial.println("Aurrera eskuinera");
}


void Motorrak::aurreraEzkerrera() //Aurrera ezkerreraka joan
{
    digitalWrite(_esk_norantza, HIGH);
    digitalWrite(_ezk_norantza, HIGH);
    analogWrite(_esk_abiadura, _abiadura);
    analogWrite(_ezk_abiadura, _abiadura-125);
    Serial.println("Aurrera ezkerrera");
}

void Motorrak::atzeraEzkerrera() //Atzera ezkerrera joan
{
    digitalWrite(_esk_norantza, LOW);
    digitalWrite(_ezk_norantza, LOW);
    analogWrite(_esk_abiadura, _abiadura);
    analogWrite(_ezk_abiadura, _abiadura-125);
    Serial.println("Atzera ezkerrera");
}

void Motorrak::atzeraEskuinera()//Atzera eskuinera joan
{
     digitalWrite(_esk_norantza, LOW);
     digitalWrite(_ezk_norantza, LOW);
     analogWrite(_esk_abiadura,_abiadura-125);
     analogWrite(_ezk_abiadura,_abiadura);
     Serial.println("Atzera eskuinera");
}

void Motorrak::gelditu() //Gelditu motor guztiak
{
     
     analogWrite(_esk_abiadura, 0); 
     analogWrite(_ezk_abiadura, 0);
     Serial.println("Gelditu");
}

void Motorrak::aldatuAbiadura(int ab_berria) //Uneko abiadura aldatu parametro gisa jasotako abiadura jarriz
{
     if(ab_berria>_abiadura){
         Serial.println("Azeleratzen...");
     }
     else{
          Serial.println("Balaztatzen...");
     }         
    _abiadura=ab_berria;   
}

 
